#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* mancano tutti i test su I/O e memoria */

int get_id(char *autore)
{
	FILE *f = fopen("autori.csv", "r");
	int l = strlen(autore);
	char buffer[100];
	while(fgets(buffer, sizeof(buffer), f)) {
		// buffer deve iniziare con autore
		if(strncmp(buffer, autore, l)) continue;
		// il carattere successivo deve essere ";"
		if(buffer[l]==';') {
			fclose(f);
			return atoi(buffer+l+1);
		}
	}
	fclose(f);
	return -1;
}

typedef struct {
	int id;
	char *titolo;
	char *editore;
	int anno;
} *libro;

libro a2libro(char *s)
{
	char titolo[100], editore[100];
	libro new = malloc(sizeof(*new));
	sscanf(s, "%d;%[^;];%[^;];%d", &new->id, titolo, editore, &new->anno);
	new->titolo = strdup(titolo);
	new->editore = strdup(editore);
	return new;
}

#if 0
// versione alternativa, non ottimale
// la dimensione dei vari vettori utilizzati non  gestita ma  fissa

typedef struct _libro_ {
	int id;
	char titolo[60];
	char editore[40];
	int anno;
} *libro;

struct _libro_ vet_libri[100];

libro a2libro(char *s)
{
	static libro new = vet_libri;
	// con static il valore della variabile si conserva da una chiamata alla successiva
	// inoltre l'inizializzazione non viene fatta ad ogno chiamata ma una sola volta al
	// lancio del programma
	sscanf(s, "%d;%[^;];%[^;];%d", &new->id, new->titolo, new->editore, &new->anno);
	// incremento new per la prossima chiamata
	return new++;
}
#endif

void stampa_libro(libro l, FILE *f)
{
	fprintf(f, "%d:%s:%s:%d\n", l->id, l->titolo, l->editore, l->anno);
}

void stampa_libri(libro *l, FILE *f)
{
	while(*l) {
		stampa_libro(*l, f);
		l++;
	}
}

libro* leggi_libri(FILE *f)
{
	char buffer[200];
	int n = 10, i=0;
	libro *libri = malloc(n * sizeof(libro));
	while(fgets(buffer, sizeof(buffer), f)) {
		if(i<n-1) {
			n *= 2;
			libri = realloc(libri, n * sizeof(*libri));
		}
		libri[i++] = a2libro(buffer);
	}
	libri[i] = NULL;
	return libri;
}

void cerca(libro *libri, int id, FILE* f)
{
	while(*libri) {
		if((*libri)->id == id) stampa_libro(*libri, f);
		libri++;
	}
}

void libri_recenti(libro *libri, int anno, FILE* f)
{
	while(*libri) {
		if((*libri)->anno >= anno) stampa_libro(*libri, f);
		libri++;
	}
}

int cmp(libro l1, libro l2)
{
	return l1->anno-l2->anno;
}

void bubblesort(libro *vet)
{
	int i, j, k;
	for(j=0; vet[j]; j++);
	for(j--; j>0; j=k) {
		k=-1;
		for(i=0; i<j; i++) {
			if(cmp(vet[i], vet[i+1]) > 0) {
				// typeof --> il tipo dell'argomento
				typeof(*vet) tmp = vet[i];
				vet[i] = vet[i+1];
				vet[i+1] = tmp;
				k=i;
			}
		}
	}
}

int main(int argc, char *argv[])
{
	libro *libri = leggi_libri(fopen(argc>1? argv[1] : "libri.txt", "r"));
	bubblesort(libri);
	libri_recenti(libri, 2000, stdout);
	stampa_libri(libri, argc>2? fopen(argv[2], "w"): stdout);
	if(argc>3) cerca(libri, get_id(argv[3]), stdout);
	return 0;
}
