#include <stdio.h>
#include <stdlib.h>

typedef struct {
	int nrig, ncol;
	unsigned int **mat;
} matrice, *pmatrice;

void mat_alloca(pmatrice m)
{
	m->mat = malloc(m->nrig * sizeof(*m->mat));
	if (m->mat == NULL) {
		perror(__func__);
		exit(1);
	}
	m->mat[0] = malloc(m->nrig * m->ncol * sizeof(**m->mat));
	if (m->mat[0] == NULL) {
		perror(__func__);
		exit(1);
	}
	int i;
	for (i = 1; i < m->nrig; i++) {
    	m->mat[i] = m->mat[i-1]+m->ncol;
	}
}

void mat_stampa(pmatrice mat, FILE* f)
{
	int i, j;
	fprintf(f, "%d %d\n", mat->nrig, mat->ncol);
	for(i=0; i<mat->nrig; i++) {
		for(j=0; j<mat->ncol; j++) {
			fprintf(f, "%2d ", mat->mat[i][j]);
		}
		fprintf(f, "\n");
	}
	fprintf(f, "\n");
}

void mat_leggi(pmatrice mat, FILE* f)
{
	int i, j;
	fscanf(f, "%d %d", &mat->nrig, &mat->ncol);
	mat_alloca(mat);
	for(i=0; i<mat->nrig; i++) {
		for(j=0; j<mat->ncol; j++) {
			fscanf(f, "%ud ", &mat->mat[i][j]);
		}
	}
}

void mat_leggi_da_file(pmatrice mat, char *fn)
{
	FILE *f = fopen(fn, "r");
	if(!f) {
		perror(fn);
		exit(1);
	}
	mat_leggi(mat, f);
}

void mat_stampa_su_file(pmatrice mat, char *fn)
{
	FILE *f = fopen(fn, "w");
	if(!f) {
		perror(fn);
		exit(1);
	}
	mat_stampa(mat, f);
}

int cmp(int *a1, int *a2, int l)
{
	for(;l>0; l--, a1++, a2++) {
		if(*a1>*a2) return -1;
		if(*a1<*a2) return 1;
	}
	return 0;
}

double media(pmatrice mat)
{
	int i, j, max, min, somma = 0;
	max = min = mat->mat[0][0];
	for(i=0; i<mat->nrig; i++) {
		for(j=0; j<mat->ncol; j++) {
			int val = mat->mat[i][j];
			somma += val;
			if(val>max) max = val;
			else if(val<min) min = val;
		}
	}
	return (somma - max - min)/(double) (mat->nrig*mat->ncol-2);
}

void mat_bubblesort(pmatrice mat)
{
	unsigned int **m = mat->mat;
	int i, j, k;
	for(j=mat->nrig-1; j>0; j=k) {
		k=-1;
		for(i=0; i<j; i++) {
			if(cmp(m[i], m[i+1], mat->ncol) > 0) {
				typeof(*m) tmp = m[i];
				m[i] = m[i+1];
				m[i+1] = tmp;
				k=i;
			}
		}
	}
}

int main(int argc, char *argv[])
{
	matrice mat;
	if(argc>1) {
		mat_leggi_da_file(&mat, argv[1]);
	} else {
		mat_leggi(&mat, stdin);
	}
	mat_stampa(&mat, stderr);
	printf("Valor medio: %f\n", media(&mat));
	mat_bubblesort(&mat);
	if(argc>2) {
		mat_stampa_su_file(&mat, argv[2]);
	} else {
		mat_stampa(&mat, stdout);
	}
	return 0;
}

#if 0
esempio-dati
9 10
10 11 37 48 67 21 87 16 98 63
26 80 78 10 53 11 76 86 87 90
23 12 66 34 83 73 82 27 17  1
84 63 72 81  0 92 76 85 76 52
95 28 20  1 26 54 74 11 21 13
55 82 72 37 87 15 34 35  6 17
19 43 14 55 97 40 24 90 46 16
95 28 10  1 26 54 74 11 21 13
76 95 48 14 31  0 57 51 39 43
esempio-dati
#endif
